'use strict';

var ConstrucaoServices = angular.module('ConstrucaoServices', []);

ConstrucaoServices.factory('Construcao', ['Conexao',
  (Conexao) => {

    var construcaoFactory = {};

    construcaoFactory.getConstrucoes = (params, callBackFunction) => {
        Conexao.ExecutaService('getConstrucoes', params, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    construcaoFactory.getListaObras = (params, callBackFunction) => {
        Conexao.ExecutaService('getListaObras', params, false,
                (data) => {
                    callBackFunction(data);
                });
    }

    construcaoFactory.getListaObrasPaginacao = (params, callBackFunction) => {
        Conexao.ExecutaService('getListaObrasPaginacao', params, false,
                (data) => {
                    callBackFunction(data);
                });
    }

    construcaoFactory.getConstrucoesContabil = (params, callBackFunction) => {
        Conexao.ExecutaService('getConstrucoesContabil', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getEtapasConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getEtapasConstrucao', { IdConstrucao: idConstrucao }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getCustoEtapaConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getCustoEtapaConstrucao', { IdConstrucao: idConstrucao }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getCustoDetalhadoEtapaConstrucao = (idConstrucao, idEtapa, callBackFunction) => {
        Conexao.ExecutaService('getCustoDetalhadoEtapaConstrucao', { IdConstrucao: idConstrucao, IdEtapa: idEtapa }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getCustoEtapaConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getCustoEtapaConstrucao', { IdConstrucao: idConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getCustoDetalhadoConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getCustoDetalhadoConstrucao', { IdConstrucao: idConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setConstrucao = (construcao, callBackFunction) => {
        Conexao.ExecutaService('setConstrucao', { construcaoJson: construcao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('delConstrucao', { IdConstrucao: idConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setEtapaConstrucao = (etapa, callBackFunction) => {
        Conexao.ExecutaService('setEtapaConstrucao', { etapaJson: etapa }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delEtapaConstrucao = (etapa, callBackFunction) => {
        Conexao.ExecutaService('delEtapaConstrucao', { IdConstrucao: etapa.IdConstrucao, IdEtapa: etapa.Id }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delImagemConstrucao = (idImagem, callBackFunction) => {
        Conexao.ExecutaService('delImagemConstrucao', { IdImagem: idImagem }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getImagensConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getImagensConstrucao', { IdConstrucao: idConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getAcessosConstrucao = (params, callBackFunction) => {
        Conexao.ExecutaService('getAcessosConstrucao', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setAcessoConstrucao = (acesso, callBackFunction) => {
        Conexao.ExecutaService('setAcessoConstrucao', { IdCliente: acesso.IdCliente, IdConstrucao: acesso.IdConstrucao, Acessos: JSON.stringify(acesso.AcessosID) }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delAcessosConstrucao = (acesso, callBackFunction) => {
        Conexao.ExecutaService('delAcessosConstrucao', acesso, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getClientesConstrucao = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getClientesConstrucao', { IdConstrucao: idConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.clonarConstrucao = (params, callBackFunction) => {
        Conexao.ExecutaService('clonarConstrucao', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.finalizarConstrucao = (IdConstrucao, DataFinalizada, callBackFunction) => {
        Conexao.ExecutaService('finalizarConstrucao', { IdConstrucao: IdConstrucao, DataFinalizada: DataFinalizada  }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.reabrirConstrucao = (IdConstrucao, callBackFunction) => {
        Conexao.ExecutaService('reabrirConstrucao', { IdConstrucao: IdConstrucao  }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getPreviewLancamentoAvanco = (idConstrucao, dataInicio, dataFim, callBackFunction) => {
        Conexao.ExecutaService('getPreviewLancamentoAvanco', { IdConstrucao: idConstrucao, DataInicio: dataInicio, DataFim: dataFim }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setLancamentoAvanco = (idConstrucao, dataInicio, dataFim, callBackFunction) => {
        Conexao.ExecutaService('setLancamentoAvanco', { IdConstrucao: idConstrucao, DataInicio: dataInicio, DataFim: dataFim }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getComposicoes = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getComposicoes', { IdConstrucao: idConstrucao }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getComposicao = (idConstrucao, idMaterial, callBackFunction) => {
        Conexao.ExecutaService('getComposicao', { idConstrucao: idConstrucao, idMaterial: idMaterial }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getPlanejaEtapa = (IdConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getPlanejaEtapa', { IdConstrucao: IdConstrucao }, false,
        (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.delPlanejaEtapa = (idConstrucao, idEtapa, medicao, callBackFunction) => {
        Conexao.ExecutaService('delPlanejaEtapa', { idConstrucao: idConstrucao, idEtapa: idEtapa, medicao: medicao }, false,
        (data) => {
            callBackFunction(data);
        });
    }
    
    construcaoFactory.delDocumento = (id, callBackFunction) => {
        Conexao.ExecutaService('delDocumento', { Id: id}, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getDocumentos = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getDocumentos', { IdConstrucao: idConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setOcorrencia = (idOcorrencia, idConstrucao, descricao, data, callBackFunction) => {
        Conexao.ExecutaService('setOcorrencia', { IdOcorrencia: idOcorrencia, IdConstrucao: idConstrucao, Descricao: descricao, Data: data }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delOcorrencia = (idOcorrencia, callBackFunction) => {
        Conexao.ExecutaService('delOcorrencia', { IdOcorrencia: idOcorrencia }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getOcorrencias = (idConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getOcorrencias', { IdConstrucao: idConstrucao }, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getListaConfiguracao = (callBackFunction) => {
        Conexao.ExecutaService('getListaConfiguracao', {}, false,
            (data) => {
                callBackFunction(data);
            });
    }
    
    construcaoFactory.getListaGrupo = (params, callBackFunction) => {
        Conexao.ExecutaService('getListaGrupo', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setGrupoObra = (IdConstrucao, ListaGrupo, callBackFunction) => {
        Conexao.ExecutaService('setGrupoObra', { IdConstrucao: IdConstrucao, ListaGrupo: JSON.stringify(ListaGrupo) }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getGrupoObra = (IdConstrucao, callBackFunction) => {
        Conexao.ExecutaService('getGrupoObra', { IdConstrucao: IdConstrucao }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.duplicaEtapa = (IdConstrucao, IdEtapa, callBackFunction) => {
        Conexao.ExecutaService('duplicaEtapa', { IdConstrucao: IdConstrucao, IdEtapa: IdEtapa }, true,
            (data) => {
                callBackFunction(data);
            });
    }
    
    construcaoFactory.duplicaComposicao = (IdConstrucao, IdComposicao, IdEtapa, Ordem, callBackFunction) => {
        Conexao.ExecutaService('duplicaComposicao', { IdConstrucao: IdConstrucao, IdComposicao: IdComposicao, IdEtapa: IdEtapa, Ordem: Ordem }, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getCronogramaEtapa = (IdConstrucao, IdEtapa, callBackFunction) => {
        Conexao.ExecutaService('getCronogramaEtapa', { IdConstrucao: IdConstrucao, IdEtapa: IdEtapa }, false,
        (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.getCronogramaItem = (IdConstrucao, IdEtapa, IdMaterial, callBackFunction) => {
        Conexao.ExecutaService('getCronogramaItem', { IdConstrucao: IdConstrucao, IdEtapa: IdEtapa, IdMaterial: IdMaterial }, false,
        (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.setPlanejaEtapa = (medicao, callBackFunction) => {
        Conexao.ExecutaService('setPlanejaEtapa', medicao, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delPlanejaEtapa = (medicao, callBackFunction) => {
        Conexao.ExecutaService('delPlanejaEtapa', medicao, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setPlanejaItem = (medicao, callBackFunction) => {
        Conexao.ExecutaService('setPlanejaItem', medicao, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delPlanejaItem = (medicao, callBackFunction) => {
        Conexao.ExecutaService('delPlanejaItem', medicao, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.setAtividadePrecessora = (params, callBackFunction) => {
        Conexao.ExecutaService('setAtividadePrecessora', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.delAtividadePrecessora = (params, callBackFunction) => {
        Conexao.ExecutaService('delAtividadePrecessora', params, true,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getAtividadePrecessora = (params, callBackFunction) => {
        Conexao.ExecutaService('getAtividadePrecessora', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getAtividadePrecessoraObra = (params, callBackFunction) => {
        Conexao.ExecutaService('getAtividadePrecessoraObra', params, false,
            (data) => {
                callBackFunction(data);
            });
    }

    construcaoFactory.getCreditoDebitoObra = (IdConstrucao, Opcao, callBackFunction) => {
        Conexao.ExecutaService('getCreditoDebitoObra', { IdConstrucao: IdConstrucao, Opcao: Opcao }, false,
        (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.getTipoObra = (callBackFunction) => {
        Conexao.ExecutaService('getTipoObra', {}, false,
        (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.getUrlCompartilhamento = (params, callBackFunction) => {
        Conexao.ExecutaService('getUrlCompartilhamento', params, false,
         (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.getCargaArquivoObra = (callBackFunction) => {
        Conexao.ExecutaService('getCargaArquivoObra', {}, false,
        (data) => {
            callBackFunction(data);
        });
    }

    construcaoFactory.getArquivoNotaFiscalObra = (params,callBackFunction) => {
        Conexao.ExecutaService('getArquivoNotaFiscalObra', params, true,
        (data) => {
            callBackFunction(data);
        });
    }

    return construcaoFactory;
  } ]);
